#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;
using Syncfusion.Windows.Forms.HTMLUI;
using System.Text;

namespace EssentialPDFSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new PDF document being generated using Essential PDF.  At the end of the document generation, an option will be provided to view the generated PDF file. Please note that you need to have a PDF viewer installed in order to view the generated PDF file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential PDF Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
		PDFDocument pdfDoc = new PDFDocument();
		HTMLUIControl ctlHtmlUI = new HTMLUIControl();

			IPDFGraphicState props = pdfDoc.CreateGraphicState();
			props.SplitImages = true;

			string strHTML = CreateHTML();

			pdfDoc.AutoCreatePages = true;
						
			Bitmap bmpImg = CreateBitmap(strHTML);
			pdfDoc.LastPage.Graphics.DrawImage(PointF.Empty, bmpImg, props);

			pdfDoc.Save("Sample.pdf");
			//Message box confirmation to view the created PDF document.
			if (MessageBox.Show ("Do you want to view the PDF file?", "PDF File Created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the PDF file using the default Application.[Acrobat Reader]
				System.Diagnostics.Process.Start("Sample.pdf");
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}
		}
		private Bitmap CreateBitmap(string strHTML)
		{
			Syncfusion.Windows.Forms.HTMLUI.HTMLUIControl ctlHTMLUIControl = new Syncfusion.Windows.Forms.HTMLUI.HTMLUIControl();

			ctlHTMLUIControl.LoadFromString(strHTML);
			InputHTML doc =ctlHTMLUIControl.Document as InputHTML;
			doc.ClientSize = ctlHTMLUIControl.Document.RenderRoot.Size;
			return LoadFinished(doc);
		}
		private Bitmap LoadFinished(InputHTML document)
		{
			if (document == null)
				throw new ArgumentNullException("document");

			int width = document.RenderRoot.Size.Width;
			int height = document.RenderRoot.Size.Height;
			Bitmap bmp = new Bitmap(width, height);
			Graphics g = Graphics.FromImage(bmp);
			g.FillRectangle(SystemBrushes.Window, 0, 0, width, height);
			PaintEventArgs args = new PaintEventArgs(g, new Rectangle(0, 0, width, height));
			Point startPoint = new Point(-document.Margins.Left, -document.Margins.Top);
			Size oldSize = document.ClientSize;
			document.ClientSize = document.RenderRoot.Size;
			document.Draw(args, startPoint);
			g.Dispose();
			document.ClientSize = oldSize;
			return bmp;
		}	
	
		private string CreateHTML()
		{
			string strNewRoman = "<SPAN style=\"FONT-SIZE: 12pt; FONT-FAMILY: 'Times New Roman'; mso-bidi-font-size: 12.0pt; mso-fareast-font-family: 'Times New Roman'; mso-ansi-language: EN-US; mso-fareast-language: EN-US; mso-bidi-language: AR-SA\">";
			
			StringBuilder strHTML = new StringBuilder();
			strHTML.Append("<html><body><form ID=\"form1\">");
			strHTML.Append("<table>");

			#region strText Value

			string strText = "Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing Testing ";
			
			#endregion


			strHTML.Append("<tr valign=middle>");
			strHTML.Append("<td width=50></td><td width=650>");
			strHTML.Append(strNewRoman + "Objectives. </span>" + strText);
			strHTML.Append("</td><td width=50><br/></td>");
			strHTML.Append("</tr>");

			strHTML.Append("<tr valign=middle>");
			strHTML.Append("<td width=50></td><td width=650>");
			strHTML.Append(strNewRoman + "Metrics. </span>" + strText);
			strHTML.Append("</td><td width=50><br/></td>");
			strHTML.Append("</tr>");

			strHTML.Append("<tr valign=middle>");
			strHTML.Append("<td width=50></td><td width=650>");
			strHTML.Append(strNewRoman + "Payoffs. </span>" + strText);
			strHTML.Append("</td><td width=50><br/></td>");
			strHTML.Append("</tr>");

			strHTML.Append("<tr valign=middle>");
			strHTML.Append("<td width=50></td><td width=650>");
			strHTML.Append(strNewRoman + "Challenges. </span>" + strText);
			strHTML.Append("</td><td width=50><br/></td>");
			strHTML.Append("</tr>");

			strHTML.Append("<tr valign=middle>");
			strHTML.Append("<td width=50></td><td width=650>");
			strHTML.Append(strNewRoman + "Milestones. </span>" + strText);
			strHTML.Append("</td><td width=50><br/></td>");
			strHTML.Append("</tr>");

			strHTML.Append("</table><br/>");
			strHTML.Append("<table><tr><td>WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW</td></tr></table>");
			strHTML.Append("</form></body></html>");

			return strHTML.ToString();
		}
	
	}
}
